diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/options_menu.c tin-2.6.5/src/options_menu.c
--- tin-2.6.4/src/options_menu.c	2024-12-22 18:37:13.000000000 +0100
+++ tin-2.6.5/src/options_menu.c	2025-11-17 21:06:58.482553700 +0100
@@ -2736,8 +2872,33 @@ config_page(
 
 #ifdef CHARSET_CONVERSION
 						case OPT_ATTRIB_UNDECLARED_CHARSET:
-							if (prompt_option_string(option))
-								SET_STRING_ATTRIBUTE(undeclared_charset, tinrc.attrib_undeclared_charset);
+							if (prompt_option_string(option)) {
+								t_bool invalid_charset = validate_charset(tinrc.attrib_undeclared_charset) == NULL;
+
+								if (!*tinrc.attrib_undeclared_charset || invalid_charset) {
+									reset_state(OPT_ATTRIB_UNDECLARED_CHARSET);
+									if (invalid_charset) {
+										/*
+										 * reset_state() calls free(tinrc.attrib_*)
+										 * only if the attribute was previously set
+										 * so we have to free() it here for the
+										 * !validate_charset() case as it might not
+										 * have been set before
+										 */
+										FreeAndNull(tinrc.attrib_undeclared_charset);
+										error_message(2, _(txt_invalid_char_in_charset));
+									}
+									redraw_screen(OPT_ATTRIB_UNDECLARED_CHARSET);
+								} else {
+									if (!curr_scope->state->undeclared_charset)
+										curr_scope->attribute->undeclared_charset = my_malloc(sizeof(char *));
+									else
+										FreeIfNeeded(*curr_scope->attribute->undeclared_charset);
+									*curr_scope->attribute->undeclared_charset = my_strdup(tinrc.attrib_undeclared_charset);
+									curr_scope->state->undeclared_charset = TRUE;
+								}
+								changed |= MISC_OPTS;
+							}
 #	ifdef USE_ICU_UCSDET
 							if (check_state(OPT_ATTRIB_UNDECLARED_CHARSET) && check_state(OPT_ATTRIB_UNDECLARED_CS_GUESS)) {
 								reset_state(OPT_ATTRIB_UNDECLARED_CS_GUESS);
@@ -2758,6 +2919,20 @@ config_page(
 								SET_STRING_ATTRIBUTE(x_headers, tinrc.attrib_x_headers);
 							break;
 
+						case OPT_SERVERRC_ADD_CMD_LINE_OPTS:
+							if (prompt_option_string(option)) {
+								FreeIfNeeded(serverrc.add_cmd_line_opts);
+								serverrc.add_cmd_line_opts = my_strdup(tinrc.serverrc_add_cmd_line_opts);
+							}
+							break;
+
+						case OPT_SERVERRC_DISABLED_NNTP_CMDS:
+							if (prompt_option_string(option)) {
+								FreeIfNeeded(serverrc.disabled_nntp_cmds);
+								serverrc.disabled_nntp_cmds = my_strdup(tinrc.serverrc_disabled_nntp_cmds);
+							}
+							break;
+
 						default:
 							break;
 					} /* switch (option) */
@@ -2767,12 +2942,16 @@ config_page(
 				case OPT_NUM:
 					switch (option) {
 						case OPT_GETART_LIMIT:
+							if (prompt_option_num(option))
+								UPDATE_INT_ATTRIBUTES(getart_limit);
+							break;
+
 						case OPT_SCROLL_LINES:
 							if (prompt_option_num(option))
 								changed |= MISC_OPTS;
 							break;
 
-#if defined(HAVE_ALARM) && defined(SIGALRM)
+#if defined(NNTP_ABLE) && defined(HAVE_ALARM) && defined(SIGALRM)
 						case OPT_NNTP_READ_TIMEOUT_SECS:
 							if (prompt_option_num(option)) {
 								if (tinrc.nntp_read_timeout_secs < 0)
@@ -2783,7 +2962,7 @@ config_page(
 								changed |= MISC_OPTS;
 							}
 							break;
-#endif /* HAVE_ALARM && SIGALRM */
+#endif /* NNTP_ABLE && HAVE_ALARM && SIGALRM */
 
 						case OPT_REREAD_ACTIVE_FILE_SECS:
 							if (prompt_option_num(option)) {
@@ -2824,7 +3003,7 @@ config_page(
 							if (prompt_option_num(option)) {
 								if (tinrc.thread_perc < 0 || tinrc.thread_perc > 100)
 									tinrc.thread_perc = THREAD_PERC_DEFAULT;
-								UPDATE_INT_ATTRIBUTES(thread_perc);
+								UPDATE_NUM_ATTRIBUTES(thread_perc);
 							}
 							break;
 
@@ -2833,11 +3012,26 @@ config_page(
 								changed |= DISPLAY_OPTS;
 							break;
 
+						case OPT_ATTRIB_GETART_LIMIT:
+							if (prompt_option_num(option))
+								SET_INT_ATTRIBUTE(getart_limit, tinrc.attrib_getart_limit);
+							break;
+
 						case OPT_ATTRIB_THREAD_PERC:
 							if (prompt_option_num(option))
 								SET_NUM_ATTRIBUTE(thread_perc, tinrc.attrib_thread_perc);
 							break;
 
+						case OPT_SERVERRC_NNTP_PIPELINE_LIMIT:
+							if (prompt_option_num(option)) {
+								if (tinrc.serverrc_nntp_pipeline_limit < PIPELINE_LIMIT_MIN)
+									tinrc.serverrc_nntp_pipeline_limit = PIPELINE_LIMIT_MIN;
+								else if (tinrc.serverrc_nntp_pipeline_limit > PIPELINE_LIMIT_MAX)
+									tinrc.serverrc_nntp_pipeline_limit = PIPELINE_LIMIT_MAX;
+								serverrc.nntp_pipeline_limit = tinrc.serverrc_nntp_pipeline_limit;
+							}
+							break;
+
 						default:
 							break;
 					} /* switch (option) */
@@ -2865,6 +3059,14 @@ config_page(
 							}
 							break;
 
+						case OPT_SCOPE_MARKED_GLOBAL:
+						case OPT_SCOPE_MARKED_GLOBAL_MATCH:
+						case OPT_SCOPE_MARKED_LOCAL:
+						case OPT_SCOPE_MARKED_LOCAL_MATCH:
+							if (prompt_option_char(option))
+								changed |= MISC_OPTS;
+							break;
+
 						default:
 							break;
 					} /* switch (option) */
@@ -2908,6 +3110,25 @@ set_art_mark_width(
 	if (wcwidth(tinrc.art_marked_read_selected) > art_mark_width)
 		art_mark_width = wcwidth(tinrc.art_marked_read_selected);
 }
+
+
+static int
+get_scope_mark_width(
+	void)
+{
+	int scope_mark_width = 1;
+
+	if (wcwidth(tinrc.scope_marked_global) > scope_mark_width)
+		scope_mark_width = wcwidth(tinrc.scope_marked_global);
+	if (wcwidth(tinrc.scope_marked_global_match) > scope_mark_width)
+		scope_mark_width = wcwidth(tinrc.scope_marked_global_match);
+	if (wcwidth(tinrc.scope_marked_local) > scope_mark_width)
+		scope_mark_width = wcwidth(tinrc.scope_marked_local);
+	if (wcwidth(tinrc.scope_marked_local_match) > scope_mark_width)
+		scope_mark_width = wcwidth(tinrc.scope_marked_local_match);
+
+	return scope_mark_width;
+}
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
 
@@ -2935,7 +3156,7 @@ static void
 show_scope_page(
 	void)
 {
-	int i;
+	int i, prev_mark_offset = mark_offset;
 
 	signal_context = cScope;
 	currmenu = &scopemenu;
@@ -2961,6 +3182,7 @@ show_scope_page(
 	}
 
 	draw_scope_arrow();
+	mark_offset = prev_mark_offset;
 }
 
 
@@ -2984,8 +3206,10 @@ scope_page(
 	forever {
 		switch ((func = handle_keypad(scope_left, scope_right, NULL, scope_keys))) {
 			case GLOBAL_QUIT:
-				if (changed)
+				if (changed) {
 					write_attributes_file(local_attributes_file);
+					assign_attributes_to_groups();
+				}
 				clear_note_area();
 				if (oldmenu)
 					currmenu = oldmenu;
@@ -3148,7 +3372,14 @@ build_scope_line(
 	int i)
 {
 	char *sptr;
-	int len = cCOLS - 11;
+#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
+	int mark_width = get_scope_mark_width();
+	wchar_t mark;
+#else
+	char mark;
+	int mark_width = 1;
+#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+	int len = cCOLS - (10 + mark_width);
 
 #ifdef USE_CURSES
 	/*
@@ -3160,7 +3391,22 @@ build_scope_line(
 	sptr = screen[INDEX2SNUM(i)].col;
 #endif /* USE_CURSES */
 
-	snprintf(sptr, (size_t) cCOLS, "  %c %s  %-*.*s%s", (scopes[i + 1].global ? '!' : ' '), tin_ltoa(i + 1, 4), len, len, scopes[i + 1].scope, cCRLF);
+	mark = scopes[i + 1].global ? tinrc.scope_marked_global : tinrc.scope_marked_local;
+
+	if (curr_group && curr_group->scopes_list) {
+		struct t_scope_list *curr = curr_group->scopes_list;
+
+		while (curr) {
+			if (curr->scope == &scopes[i + 1]) {
+				mark = scopes[i + 1].global ? tinrc.scope_marked_global_match : tinrc.scope_marked_local_match;
+				break;
+			}
+
+			curr = curr->next;
+		}
+	}
+
+	snprintf(sptr, (size_t) cCOLS, "  %*"T_CHAR_FMT" %s  %-*.*s%s", mark_width, (T_CHAR_TYPE) mark, tin_ltoa(i + 1, 4), len, len, scopes[i + 1].scope, cCRLF);
 
 #ifndef USE_CURSES
 	if (tinrc.strip_blanks)
@@ -3337,7 +3583,7 @@ free_scopes_and_attributes(
 	}
 
 	while (num_scope > 1 && !scopes[num_scope - 1].global)
-			free_scope(--num_scope);
+		free_scope(--num_scope);
 }
 
 
@@ -3350,7 +3596,7 @@ scope_is_empty(
 {
 	enum option_enum i;
 
-	for (i = 0; i <= last_opt; i++) {
+	for (i = FIRST_OPT; i <= last_opt; i++) {
 		if (option_is_visible(i) && !option_is_title(i) && check_state(i))
 			return FALSE;
 	}
@@ -3399,10 +3645,14 @@ check_state(
 			return curr_scope->state->followup_to;
 		case OPT_ATTRIB_FROM:
 			return curr_scope->state->from;
+		case OPT_ATTRIB_GETART_LIMIT:
+			return curr_scope->state->getart_limit;
 		case OPT_ATTRIB_GROUP_CATCHUP_ON_EXIT:
 			return curr_scope->state->group_catchup_on_exit;
 		case OPT_ATTRIB_GROUP_FORMAT:
 			return curr_scope->state->group_format;
+		case OPT_ATTRIB_HIDE_INLINE_DATA:
+			return curr_scope->state->hide_inline_data;
 #ifdef HAVE_ISPELL
 		case OPT_ATTRIB_ISPELL:
 			return curr_scope->state->ispell;
@@ -3610,6 +3860,10 @@ reset_state(
 		case OPT_ATTRIB_FROM:
 			RESET_ATTRIBUTE(from, tinrc.attrib_from);
 			break;
+		case OPT_ATTRIB_GETART_LIMIT:
+			curr_scope->state->getart_limit = FALSE;
+			tinrc.attrib_getart_limit = default_scope->attribute->getart_limit;
+			break;
 		case OPT_ATTRIB_GROUP_CATCHUP_ON_EXIT:
 			curr_scope->state->group_catchup_on_exit = FALSE;
 			tinrc.attrib_group_catchup_on_exit = default_scope->attribute->group_catchup_on_exit;
@@ -3617,6 +3871,10 @@ reset_state(
 		case OPT_ATTRIB_GROUP_FORMAT:
 			RESET_ATTRIBUTE(group_format, tinrc.attrib_group_format);
 			break;
+		case OPT_ATTRIB_HIDE_INLINE_DATA:
+			curr_scope->state->hide_inline_data = FALSE;
+			tinrc.attrib_hide_inline_data = default_scope->attribute->hide_inline_data;
+			break;
 #ifdef HAVE_ISPELL
 		case OPT_ATTRIB_ISPELL:
 			RESET_ATTRIBUTE(ispell, tinrc.attrib_ispell);
@@ -3873,7 +4131,9 @@ initialize_attributes(
 #ifdef HAVE_COLOR
 	INITIALIZE_NUM_ATTRIBUTE(extquote_handling, tinrc.attrib_extquote_handling);
 #endif /* HAVE_COLOR */
+	INITIALIZE_NUM_ATTRIBUTE(getart_limit, tinrc.attrib_getart_limit);
 	INITIALIZE_NUM_ATTRIBUTE(group_catchup_on_exit, tinrc.attrib_group_catchup_on_exit);
+	INITIALIZE_NUM_ATTRIBUTE(hide_inline_data, tinrc.attrib_hide_inline_data);
 	INITIALIZE_NUM_ATTRIBUTE(mail_8bit_header, tinrc.attrib_mail_8bit_header);
 	INITIALIZE_NUM_ATTRIBUTE(mail_mime_encoding, tinrc.attrib_mail_mime_encoding);
 	INITIALIZE_NUM_ATTRIBUTE(mark_ignore_tags, tinrc.attrib_mark_ignore_tags);
